NecrosisConfig = {};
NecrosisDebuffDatabase = {};
Language = "";
DebuffSelection = "";

local Debug = false;
local Loaded = false;
local LoadedVariables = false;

local Target = {Type = nil,Name = nil};

local PlayerCombat = false;
local DemonCombat = false;

local EnemyNoticeTime = 0;

local ShadowTrance = false;
local WillOfTheForsaken = false;

local SpellCastName = nil;
local SpellCastRemove = nil;
local SpellCastTime = 0;
local SpellTimer = {Name = {},Time = {},TimeMax = {},Type = {}};
local SpellCheckTime = 0;

local Spell;

local Soulshards = 0;
local SoulshardSlot = {};
local SoulshardMP = 0;
local SoulshardTime = 0;

local SoulstoneOnHand = false;
local SoulstoneMode = 1;
local HealthstoneOnHand = false;
local HealthstoneMode = 1;
local SpellstoneOnHand = false;
local SpellstoneMode = 1;
local FirestoneOnHand = false;
local FirestoneMode = 1;
local InfernalStones = 0;
local DemonicFigurines = 0;

local DevourUnit = {};

local DemonLoaded = false;
local DemonTime = 0;
local DemonSpell = {};
local DemonType = nil;
local DemonHPTime = 0;
local DemonHPInterval = 16;
local DemonEnslaved = false;
local DemonAvoid;
local DemonSpellClick = 0;
local DemonSpellClickLast = 0;
local DemonKeepTarget = false;

---------------------------------------------------------------------------------------------------------------------------------------
-- NECROSIS FUNCTIONS
----------------------------------------------------------------------------------------------------------------------------------------

function Necrosis_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("UNIT_NAME_UPDATE");

	NecrosisTitleText:SetText(Necrosis.Title);
	NecrosisButton:RegisterForDrag("LeftButton");
	NecrosisSpellTimerButton:RegisterForDrag("LeftButton");
	NecrosisShadowTranceButton:RegisterForDrag("RightButton");

	NecrosisSummonerButton:RegisterForClicks("LeftButtonUp", "RightButtonUp");
	NecrosisSummonerSpellButton1:RegisterForClicks("LeftButtonUp", "RightButtonUp");
	NecrosisSummonerSpellButton2:RegisterForClicks("LeftButtonUp", "RightButtonUp");
	NecrosisSummonerSpellButton3:RegisterForClicks("LeftButtonUp", "RightButtonUp");
	NecrosisSummonerSpellButton4:RegisterForClicks("LeftButtonUp", "RightButtonUp");
	NecrosisSummonerSpellButton5:RegisterForClicks("LeftButtonUp", "RightButtonUp");
	NecrosisSummonerSpellButton6:RegisterForClicks("LeftButtonUp", "RightButtonUp");
	NecrosisSummonerSpellButton7:RegisterForClicks("LeftButtonUp", "RightButtonUp");
	NecrosisSummonerSpellButton8:RegisterForClicks("LeftButtonUp", "RightButtonUp");

	SlashCmdList["NecrosisCommand"] = Necrosis_SlashHandler;
	SLASH_NecrosisCommand1 = "/necrosis";
end

function Necrosis_OnUpdate()
	if (not Loaded) then
		return;
	elseif (UnitClass("player") ~= Necrosis.Variable[Language].Warlock) then
		return;
	end
	-- See if we can add to the debuff database
	Necrosis_CheckDebuffDatabase();
	local curTime = GetTime();
	-- Soulshard Management
	if ((curTime-SoulshardTime) > 1) then
		SoulshardTime = curTime;
		if (SoulshardMP > 0) then
			Necrosis_SoulshardSwitch("Move");
		end
	end
	-- Spell Management
	if (NecrosisConfig.ShadowTranceAlert) then
		if (Necrosis_UnitHasEffect("player", Necrosis.Variable[Language].Spell7)) then
			if (not ShadowTrance) then
				ShadowTrance = true;
				if (NecrosisConfig.PlaySounds) then
					PlaySoundFile("Interface\\AddOns\\Necrosis\\Sounds\\ShadowTrance.mp3");
				else
					Necrosis_Msg("<white>"..Necrosis.Variable[Language].Spell7, "USER");
					PlaySound("MapPing");
				end
				NecrosisShadowTranceButton:Show();
			end
		else
			if (NecrosisShadowTranceButton:IsVisible()) then
				ShadowTrance = false;
				NecrosisShadowTranceButton:Hide();
			end
		end
		if (Necrosis_UnitHasEffect("target", Necrosis.Variable[Language].Spell8)) then
			if (not WillOfTheForsaken) then
				WillOfTheForsaken = true;
				Necrosis_Msg("<white>"..Necrosis.Variable[Language].Spell8, "USER");
			end
		else
			WillOfTheForsaken = false;
		end
	end
	if (NecrosisConfig.ShowSpellTimers) then
		-- Make sure spell list is on the right side
		if (NecrosisSpellTimerButton:GetCenter() >= NecrosisOptionMenu:GetCenter()) then
			NecrosisListSpells:SetPoint("TOPLEFT", "NecrosisSpellTimerButton", "TOPLEFT", -175, -10);
		else
			NecrosisListSpells:SetPoint("TOPLEFT", "NecrosisSpellTimerButton", "TOPLEFT", 40, -10);
		end
		if (not NecrosisSpellTimerButton:IsVisible()) then
			NecrosisSpellTimerButton:Show();
		end
		if ((curTime-SpellCheckTime) >= .5) then
			SpellCheckTime = curTime;
			Necrosis_SpellTimerTarget("Check");
		end
		local update = false;
		if ((curTime-SpellCastTime) >= 1) then
			SpellCastTime = curTime;
			update = true;
		end
		local timerDisplay = "";
		for index=1, table.getn(SpellTimer.Name), 1 do
			if (SpellTimer.Time[index] > 0) then
				local percent = floor((SpellTimer.Time[index]/SpellTimer.TimeMax[index])*100);
				local color = "<brightGreen>";
				if (percent < 10) then
					color = "<red>";
				elseif (percent < 20) then
					color = "<redOrange>";
				elseif (percent < 30) then
					color = "<darkOrange>";
				elseif (percent < 40) then
					color = "<dirtyOrange>";
				elseif (percent < 50) then
					color = "<darkYellow>";
				elseif (percent < 60) then
					color = "<lightYellow>";
				elseif (percent < 70) then
					color = "<yellowGreen>";
				elseif (percent < 80) then
					color = "<lightGreen1>";
				elseif (percent < 90) then
					color = "<lightGreen2>";
				end
				-- Count up/down on the current timer
				local countDirection = "DOWN";
				if (SpellTimer.Name[index] == Necrosis.Variable[Language].Spell1) then
					countDirection = "UP";
				end
				-- Display the formated timer
				timerDisplay = timerDisplay..color..SpellTimer.Name[index]..": <close>".."<white>";
				local seconds = 0;
				if (countDirection == "UP") then
					seconds = SpellTimer.TimeMax[index]-SpellTimer.Time[index];
				else
					seconds = SpellTimer.Time[index];
				end
				local minutes = floor(seconds/60);
				if (minutes > 0) then
					if (minutes > 9) then
						timerDisplay = timerDisplay..minutes..":"
					else
						timerDisplay = timerDisplay.."0"..minutes..":"
					end
				else
				timerDisplay = timerDisplay.."0:"
				end
				seconds = mod(seconds, 60);
				if (seconds > 9) then
					timerDisplay = timerDisplay..seconds.."<close>\n";
				else
					timerDisplay = timerDisplay.."0"..seconds.."<close>\n";
				end
				if (update) then


					local isSoulstone = (SpellTimer.Name[index] == Necrosis.Variable[Language].Spell2);
					if (isSoulstone) then
						local timeLeft, isMinutes = Necrosis_GetSoulStoneTime();
						if (timeLeft ~= nil) then
							if (isMinutes) then
								SpellTimer.Time[index] = timeLeft*60+1;
							else
								SpellTimer.Time[index] = timeLeft;
							end
						end
					end
					SpellTimer.Time[index] = SpellTimer.Time[index]-1;
					if (SpellTimer.Time[index] <= 0) then
						if (isSoulstone) then
							Necrosis_UpdateStoneButtons();
							Necrosis_Msg(Necrosis.Variable[Language].MsgSSDone, "USER");
							if (NecrosisConfig.PlaySounds) then
								PlaySoundFile("Interface\\AddOns\\Necrosis\\Sounds\\Soulstone.mp3");
							end
						end
						table.remove(SpellTimer.Name, index);
						table.remove(SpellTimer.Time, index);
						table.remove(SpellTimer.TimeMax, index);
						table.remove(SpellTimer.Type, index);
						break;
					end
				end
			end
		end
		timerDisplay = Necrosis_MsgAddColor(timerDisplay);
		NecrosisListSpells:SetText(timerDisplay);
	else
		if (NecrosisSpellTimerButton:IsVisible()) then
			NecrosisListSpells:SetText("");
			NecrosisSpellTimerButton:Hide();
		end
	end
	Necrosis_DisplayStoneButtons();
	-- Demon Management
	if (DemonType ~= nil) then
		if (not DemonLoaded) then
			Necrosis_DemonSetup();
		end
		if (NecrosisConfig.DemonMonitor) then
			Necrosis_DemonMonitor(curTime);
		end
		if (NecrosisConfig.DemonLeash and PlayerCombat) then		
			Necrosis_DemonLeash();
		end
		if (NecrosisConfig[DemonType].UseSpells) then
			if ((curTime-DemonTime) >= .5) then
				DemonTime = curTime;
				Necrosis_DemonSpellCaster();
			end
		end			
	end
end

function Necrosis_OnEvent(event)
	if (event == "VARIABLES_LOADED") then
		LoadedVariables = true;
	elseif (event == "UNIT_NAME_UPDATE" and arg1 == "player") then
		if (LoadedVariables) then
			Necrosis_Initialize();
		end
	elseif (event == "BAG_UPDATE") then
		if (NecrosisConfig.SoulshardSort) then
			Necrosis_SoulshardSwitch("Check");
		end
		Necrosis_SoulshardTotal();
	elseif (event == "UNIT_INVENTORY_CHANGED") then
		Necrosis_SoulshardTotal();
	elseif (event == "PLAYER_REGEN_DISABLED") then
		PlayerCombat = true;
		-- Enemy notice alerts
		local faction = UnitFactionGroup("target");
		if (faction == "Horde" or faction == "Alliance") then
			if (faction ~= UnitFactionGroup("player")) then
				if (NecrosisConfig.EnemyNotice) then
					local curTime = GetTime();
					if ((curTime-EnemyNoticeTime) >= 20) then
						EnemyNoticeTime = curTime;			
						Necrosis_Msg("["..string.upper(faction).."] "..Necrosis.Variable[Language].MsgHordeAttack..UnitName("target").." ("..tostring(UnitLevel("target")).." "..UnitClass("target")..") HP: "..UnitHealth("target").."%", "WORLD");
					end
				end
			end
		end
	elseif (event == "PLAYER_REGEN_ENABLED") then
		Necrosis_SpellTimerTarget("Clear", 2);
		PlayerCombat = false;
		DemonCombat = false;
		ShadowTrance = false;
	elseif (event == "PLAYER_PET_CHANGED") then
		DemonCombat = false;
		DemonType = UnitCreatureFamily("pet");
		DemonLoaded = false;
	elseif (event == "UNIT_COMBAT") then
		if (DemonType ~= nil) then
			if (NecrosisConfig[DemonType].FollowFocus and not DemonCombat and not DemonKeepTarget) then
				Necrosis_DemonAttack("Player");
			end
		end
	elseif (event == "UNIT_FOCUS") then
		Necrosis_SpellTimerTarget("Clear", 2);
		if (DemonType ~= nil) then
			if (NecrosisConfig[DemonType].FollowFocus and PlayerCombat and not DemonKeepTarget) then		
				Necrosis_DemonAttack("Player");
			end
		end
	elseif (event == "PET_ATTACK_START") then
		DemonCombat = true;
	elseif (event == "PET_ATTACK_STOP") then
		DemonCombat = false;
	elseif (event == "SPELLCAST_START") then
		SpellCastName = arg1;
		SpellCastRemove = nil;
	elseif (event == "SPELLCAST_FAILED") then
		if (SpellCastRemove ~= nil) then
			Necrosis_SpellTimerManage("Remove", SpellCastRemove);
			SpellCastRemove = nil;
		end
	elseif (event == "SPELLCAST_INTERRUPTED") then
		if (SpellCastRemove ~= nil) then
			Necrosis_SpellTimerManage("Remove", SpellCastRemove);
			SpellCastRemove = nil;
		end
	elseif (event == "SPELLCAST_STOP") then
		Necrosis_SpellTimerTarget("Check");
		if (SpellCastName == Necrosis.Variable[Language].spellName[2]) then
			Necrosis_SpellTimerManage("Insert", SpellCastName, 1);
		elseif (SpellCastName == Necrosis.Variable[Language].spellName[6]) then
			local unitName = UnitName("target");
			if (unitName) then
				Necrosis_Msg(Necrosis.Variable[Language].MsgPortal1..unitName..Necrosis.Variable[Language].MsgPortal2, "WORLD");
			end
		end
		SpellCastRemove = SpellCastName;
		SpellCastName = nil;
	elseif (event == "LEARNED_SPELL_IN_TAB") then
		Necrosis_SpellSetup();
	elseif (event == "CHAT_MSG_MONSTER_EMOTE") then
		-- Don't allow demon to chase the enemy
		if (NecrosisConfig.DemonLeash and DemonCombat) then
			if (string.find(arg1, Necrosis.Variable[Language].DemonLeash0)) then
				if (Debug) then Necrosis_Msg("<white>DemonLeash: <lightOrange>Target is fleeing!", "USER"); end
				PetFollow();
			end
		end
	elseif (event == "CHAT_MSG_COMBAT_SELF_HITS" or event == "CHAT_MSG_COMBAT_SELF_MISSES" or event == "CHAT_MSG_SPELL_SELF_DAMAGE" or event == "CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_DAMAGE" or event == "CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE") then
		if (NecrosisConfig.PlaySounds) then
			for spell, creatureName, damage in string.gfind(arg1, Necrosis.Variable[Language].CombatParse1) do
				PlaySoundFile("Interface\\AddOns\\Necrosis\\Sounds\\CriticalDamage.mp3");
				return;
			end
			for creatureName, damage in string.gfind(arg1, Necrosis.Variable[Language].CombatParse2) do
				PlaySoundFile("Interface\\AddOns\\Necrosis\\Sounds\\CriticalDamage.mp3");
				return;
			end
		end
	end
end

function Necrosis_Initialize()
	Language = "ENGLISH";
	if (UnitClass("player") == Necrosis.Variable["GERMAN"].Warlock) then
		Language = "GERMAN";
	elseif (UnitClass("player") == Necrosis.Variable["FRENCH"].Warlock) then
		Language = "FRENCH";
	end
	if (Loaded) then
		return;
	elseif (UnitClass("player") ~= Necrosis.Variable[Language].Warlock) then
		Loaded = true;
		HideUIPanel(NecrosisOptionMenu);
		HideUIPanel(NecrosisImpOptionMenu);
		HideUIPanel(NecrosisVoidwalkerOptionMenu);
		HideUIPanel(NecrosisSuccubusOptionMenu);
		HideUIPanel(NecrosisFelhunterOptionMenu);
		HideUIPanel(NecrosisInfernalOptionMenu);
		HideUIPanel(NecrosisDoomguardOptionMenu);
		HideUIPanel(NecrosisSpellTimerButton);
		HideUIPanel(NecrosisButton);
		HideUIPanel(NecrosisDigitalCounter);
		HideUIPanel(NecrosisSummonerButton);
		HideUIPanel(NecrosisSummonerMenu);
		HideUIPanel(NecrosisMountButton);
		HideUIPanel(NecrosisFirestoneButton);
		HideUIPanel(NecrosisSpellstoneButton);
		HideUIPanel(NecrosisHealthstoneButton);
		HideUIPanel(NecrosisSoulstoneButton);
		HideUIPanel(DebuffDatabaseFrame);
		Necrosis_Msg(Necrosis.Variable[Language].MsgClassError, "USER");
	else
		Loaded = true;
		Necrosis_ChangeLanguage();
		Spell = Necrosis.Variable[Language].Spell;
		DemonAvoid = Necrosis.Variable[Language].DemonAvoid;

		local tableMatch = true;
		if (type(NecrosisConfig) ~= "table") then
			tableMatch = false;
		else
			for key, value in pairs(Default_NecrosisConfig) do
				if (type(Default_NecrosisConfig[key]) ~= type(NecrosisConfig[key])) then
					tableMatch = false;
					break;
				end
			end
		end
		if (not tableMatch or NecrosisConfig.Version ~= Default_NecrosisConfig.Version) then
			Necrosis_ResetConfig();
			NecrosisConfig = Default_NecrosisConfig;

			NecrosisSpellTimerButton:SetPoint("TOPLEFT", "NecrosisButton", "TOPLEFT", -36, -16); 
			NecrosisButton:SetPoint("TOPLEFT", "MinimapBackdrop", "TOPLEFT", -30, -150);

			Necrosis_Msg(Necrosis.Variable[Language].MsgReset, "USER");
		else
			Necrosis_Msg(Necrosis.Variable[Language].MsgLoaded, "USER");
		end
		if (type(NecrosisDebuffDatabase.Name) ~= "table" or table.getn(NecrosisDebuffDatabase.Name) == 0) then
			NecrosisDebuffDatabase.Name = Necrosis.DebuffDatabase[Language].Name;
			NecrosisDebuffDatabase.Description = Necrosis.DebuffDatabase[Language].Description;
		end
		RegisterForSave("NecrosisConfig");
		RegisterForSave("NecrosisDebuffDatabase");

		this:RegisterEvent("BAG_UPDATE");
		this:RegisterEvent("CHAT_MSG_MONSTER_EMOTE");
		this:RegisterEvent("CHAT_MSG_COMBAT_SELF_HITS");
		this:RegisterEvent("CHAT_MSG_COMBAT_SELF_MISSES");
		this:RegisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE");
		this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE");
		this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_DAMAGE");
		this:RegisterEvent("PET_ATTACK_START");
		this:RegisterEvent("PET_ATTACK_STOP");
		this:RegisterEvent("PLAYER_REGEN_DISABLED");
		this:RegisterEvent("PLAYER_REGEN_ENABLED");
		this:RegisterEvent("PLAYER_PET_CHANGED");
		this:RegisterEvent("SPELLCAST_START");
		this:RegisterEvent("SPELLCAST_FAILED");
		this:RegisterEvent("SPELLCAST_INTERRUPTED");
		this:RegisterEvent("SPELLCAST_STOP");
		this:RegisterEvent("LEARNED_SPELL_IN_TAB");
		this:RegisterEvent("UNIT_COMBAT");
		this:RegisterEvent("UNIT_FOCUS");
		this:RegisterEvent("UNIT_INVENTORY_CHANGED");

		Necrosis_SpellSetup();
		Necrosis_SoulshardSetup();
		Necrosis_SoulshardTotal();
		Necrosis_OnEvent("PLAYER_PET_CHANGED");

		if (NecrosisConfig.HordeNotice) then NecrosisSection0Button1:SetChecked(1); end
		if (NecrosisConfig.PlaySounds) then NecrosisSection0Button2:SetChecked(1); end
		if (NecrosisConfig.SoulshardIcon) then NecrosisSection0Button3:SetChecked(1); end

		NecrosisUIScaleSlider:SetValue(NecrosisConfig.UIScale);
		NecrosisButton:SetScale(NecrosisConfig.UIScale);
		NecrosisDigitalCounter:SetScale(NecrosisConfig.UIScale);
		--NecrosisSpellTimerButton:SetScale(NecrosisConfig.UIScale);
		NecrosisSummonerButton:SetScale(NecrosisConfig.UIScale);
		NecrosisSummonerMenu:SetScale(NecrosisConfig.UIScale);
		NecrosisMountButton:SetScale(NecrosisConfig.UIScale);
		NecrosisFirestoneButton:SetScale(NecrosisConfig.UIScale);
		NecrosisSpellstoneButton:SetScale(NecrosisConfig.UIScale);
		NecrosisHealthstoneButton:SetScale(NecrosisConfig.UIScale);
		NecrosisSoulstoneButton:SetScale(NecrosisConfig.UIScale);

		if (NecrosisConfig.SoulshardSort) then NecrosisSection1Button1:SetChecked(1); end
		if (NecrosisConfig.SoulshardDestroy) then NecrosisSection1Button2:SetChecked(1); end
		if (NecrosisConfig.ShadowTranceAlert) then NecrosisSection2Button1:SetChecked(1); end
		if (NecrosisConfig.ShowSpellTimers) then NecrosisSection2Button2:SetChecked(1); end
		if (NecrosisConfig.ShowSummoner) then NecrosisSection2Button3:SetChecked(1); end
		if (NecrosisConfig.ShowMount) then NecrosisSection2Button4:SetChecked(1); end
		if (NecrosisConfig.ShowSoulstone) then NecrosisSection2Button5:SetChecked(1); end
		if (NecrosisConfig.ShowHealthstone) then NecrosisSection2Button6:SetChecked(1); end
		if (NecrosisConfig.ShowSpellstone) then NecrosisSection2Button7:SetChecked(1); end
		if (NecrosisConfig.ShowFirestone) then NecrosisSection2Button8:SetChecked(1); end
		if (NecrosisConfig.DemonMonitor) then NecrosisSection3Button1:SetChecked(1); end
		if (NecrosisConfig.DemonLeash) then NecrosisSection3Button2:SetChecked(1); end
		if (NecrosisConfig[Necrosis.Variable[Language].Imp].FollowFocus) then NecrosisImpButton1:SetChecked(1); end
		if (NecrosisConfig[Necrosis.Variable[Language].Imp].UseSpells) then NecrosisImpButton2:SetChecked(1); end
		if (NecrosisConfig[Necrosis.Variable[Language].Voidwalker].FollowFocus) then NecrosisVoidwalkerButton1:SetChecked(1); end
		if (NecrosisConfig[Necrosis.Variable[Language].Voidwalker].UseSpells) then NecrosisVoidwalkerButton2:SetChecked(1); end
		NecrosisVoidwalkerSlider1:SetValue(NecrosisConfig[Necrosis.Variable[Language].Voidwalker].SacrificeDemon*100);
		NecrosisVoidwalkerSlider2:SetValue(NecrosisConfig[Necrosis.Variable[Language].Voidwalker].SacrificePlayer*100);
		NecrosisVoidwalkerSlider3:SetValue(NecrosisConfig[Necrosis.Variable[Language].Voidwalker].ConsumeShadows*100);
		NecrosisVoidwalkerSlider4:SetValue(NecrosisConfig[Necrosis.Variable[Language].Voidwalker].ConsumeShadowsMana*100);
		if (NecrosisConfig[Necrosis.Variable[Language].Succubus].FollowFocus) then NecrosisSuccubusButton1:SetChecked(1); end
		if (NecrosisConfig[Necrosis.Variable[Language].Succubus].UseSpells) then NecrosisSuccubusButton2:SetChecked(1); end
		if (NecrosisConfig[Necrosis.Variable[Language].Felhunter].FollowFocus) then NecrosisFelhunterButton1:SetChecked(1); end
		if (NecrosisConfig[Necrosis.Variable[Language].Felhunter].UseSpells) then NecrosisFelhunterButton2:SetChecked(1); end
		if (NecrosisConfig[Necrosis.Variable[Language].Felhunter].DevourByName) then NecrosisFelhunterButton3:SetChecked(1); end
		if (NecrosisConfig[Necrosis.Variable[Language].Felhunter].Player) then NecrosisFelhunterButton4:SetChecked(1); end
		if (NecrosisConfig[Necrosis.Variable[Language].Felhunter].Pet) then NecrosisFelhunterButton5:SetChecked(1); end
		if (NecrosisConfig[Necrosis.Variable[Language].Felhunter].Party) then NecrosisFelhunterButton6:SetChecked(1); end
		if (NecrosisConfig[Necrosis.Variable[Language].Felhunter].Raid) then NecrosisFelhunterButton7:SetChecked(1); end
		if (NecrosisConfig[Necrosis.Variable[Language].Infernal].FollowFocus) then NecrosisInfernalButton1:SetChecked(1); end
		if (NecrosisConfig[Necrosis.Variable[Language].Doomguard].FollowFocus) then NecrosisDoomguardButton1:SetChecked(1); end
		if (NecrosisConfig[Necrosis.Variable[Language].Doomguard].UseSpells) then NecrosisDoomguardButton2:SetChecked(1); end
		Necrosis_Msg(Necrosis.Variable[Language].MsgHelp, "USER");
	end
end

function Necrosis_ResetConfig()
	Default_NecrosisConfig.SummonDemon = 1;
	Default_NecrosisConfig[Necrosis.Variable[Language].Imp]= {
		FollowFocus = false,
		UseSpells = false
	}
	Default_NecrosisConfig[Necrosis.Variable[Language].Voidwalker] = {
		FollowFocus = false,
		UseSpells = false,
		ConsumeShadows = 0.7,
		ConsumeShadowsMana = 0.45,
		SacrificeDemon = 0.25,
		SacrificePlayer = 0.25
	}
	Default_NecrosisConfig[Necrosis.Variable[Language].Succubus] = {
		FollowFocus = false,
		UseSpells = false,
		Invisible = 0.5,
		Seduction = 0.5
	}
	Default_NecrosisConfig[Necrosis.Variable[Language].Felhunter] = {
		FollowFocus = false,
		UseSpells = false,
		DevourNotice = false,
		DevourByName = false,
		Player = true,
		Pet = true,
		Party = true,
		Raid = true
	}
	Default_NecrosisConfig[Necrosis.Variable[Language].Infernal] = {
		FollowFocus = false
	}
	Default_NecrosisConfig[Necrosis.Variable[Language].Doomguard] = {
		FollowFocus = false,
		UseSpells = false
	}
end

function Necrosis_ChangeLanguage()
	NecrosisSection0Option1:SetText(Necrosis.Interface[Language][2]);
	NecrosisSection0Option2:SetText(Necrosis.Interface[Language][3]);
	NecrosisSection0Option3:SetText(Necrosis.Interface[Language][4]);
	NecrosisSectionUIScale:SetText(Necrosis.Interface[Language][5]);
	NecrosisSection1:SetText(Necrosis.Interface[Language][6]);
	NecrosisSection1Option1:SetText(Necrosis.Interface[Language][7]);
	NecrosisSection1Option2:SetText(Necrosis.Interface[Language][8]);
	NecrosisSection2:SetText(Necrosis.Interface[Language][9]);
	NecrosisSection2Option1:SetText(Necrosis.Interface[Language][10]);
	NecrosisSection2Option2:SetText(Necrosis.Interface[Language][11]);
	NecrosisSection2Option3:SetText(Necrosis.Interface[Language][12]);
	NecrosisSection3:SetText(Necrosis.Interface[Language][13]);
	NecrosisSection3Option1:SetText(Necrosis.Interface[Language][14]);
	NecrosisSection3Option2:SetText(Necrosis.Interface[Language][15]);
	NecrosisSectionUIScaleButton:SetText(Necrosis.Interface[Language][16]);
	NecrosisSectionSortButton:SetText(Necrosis.Interface[Language][17]);
	ImpButton:SetText(Necrosis.Interface[Language][18]);
	VoidwalkerButton:SetText(Necrosis.Interface[Language][19]);
	SuccubusButton:SetText(Necrosis.Interface[Language][20]);
	FelhunterButton:SetText(Necrosis.Interface[Language][21]);
	InfernalButton:SetText(Necrosis.Interface[Language][22]);
	DoomguardButton:SetText(Necrosis.Interface[Language][23]);
	DebuffDatabaseButton:SetText(Necrosis.Interface[Language][24]);
	NecrosisImpTitle:SetText(Necrosis.Interface[Language][25]);
	NecrosisVoidwalkerTitle:SetText(Necrosis.Interface[Language][26]);
	NecrosisSuccubusTitle:SetText(Necrosis.Interface[Language][27]);
	NecrosisFelhunterTitle:SetText(Necrosis.Interface[Language][28]);
	NecrosisInfernalTitle:SetText(Necrosis.Interface[Language][29]);
	NecrosisDoomguardTitle:SetText(Necrosis.Interface[Language][30]);
	NecrosisImpOption1:SetText(Necrosis.Interface[Language][31]);
	NecrosisImpOption2:SetText(Necrosis.Interface[Language][32]);	
	NecrosisVoidwalkerOption1:SetText(Necrosis.Interface[Language][31]);
	NecrosisVoidwalkerOption2:SetText(Necrosis.Interface[Language][32]);
	NecrosisSuccubusOption1:SetText(Necrosis.Interface[Language][31]);
	NecrosisSuccubusOption2:SetText(Necrosis.Interface[Language][32]);
	NecrosisFelhunterOption1:SetText(Necrosis.Interface[Language][31]);
	NecrosisFelhunterOption2:SetText(Necrosis.Interface[Language][32]);
	NecrosisFelhunterOption3:SetText(Necrosis.Interface[Language][33]);
	NecrosisFelhunterOption4:SetText(Necrosis.Interface[Language][34]);
	NecrosisFelhunterOption5:SetText(Necrosis.Interface[Language][35]);
	NecrosisFelhunterOption6:SetText(Necrosis.Interface[Language][36]);
	NecrosisFelhunterOption7:SetText(Necrosis.Interface[Language][37]);
	NecrosisFelhunterOption8:SetText(Necrosis.Interface[Language][38]);	
	NecrosisInfernalOption1:SetText(Necrosis.Interface[Language][31]);	
	NecrosisDoomguardOption1:SetText(Necrosis.Interface[Language][31]);
	NecrosisDoomguardOption2:SetText(Necrosis.Interface[Language][32]);
end

function Necrosis_MsgAddColor(msg)
	msg = string.gsub(msg, "<white>", "|CFFFFFFFF");
	msg = string.gsub(msg, "<lightBlue>", "|CFF99CCFF");
	msg = string.gsub(msg, "<brightGreen>", "|CFF00FF00");
	msg = string.gsub(msg, "<lightGreen2>", "|CFF66FF66");
	msg = string.gsub(msg, "<lightGreen1>", "|CFF99FF66");
	msg = string.gsub(msg, "<yellowGreen>", "|CFFCCFF66");
	msg = string.gsub(msg, "<lightYellow>", "|CFFFFFF66");
	msg = string.gsub(msg, "<darkYellow>", "|CFFFFCC00");
	msg = string.gsub(msg, "<lightOrange>", "|CFFFFCC66");
	msg = string.gsub(msg, "<dirtyOrange>", "|CFFFF9933");
	msg = string.gsub(msg, "<darkOrange>", "|CFFFF6600");
	msg = string.gsub(msg, "<redOrange>", "|CFFFF3300");
	msg = string.gsub(msg, "<red>", "|CFFFF0000");
	msg = string.gsub(msg, "<lightRed>", "|CFFFF5555");
	msg = string.gsub(msg, "<lightPurple1>", "|CFFFFC4FF");
	msg = string.gsub(msg, "<lightPurple2>", "|CFFFF99FF");
	msg = string.gsub(msg, "<purple>", "|CFFFF50FF");
	msg = string.gsub(msg, "<darkPurple1>", "|CFFFF00FF");
	msg = string.gsub(msg, "<darkPurple2>", "|CFFB700B7");
	msg = string.gsub(msg, "<close>", "|r");
	return msg;
end

function Necrosis_Msg(msg, type)
	if (msg and type) then
		if (type == "USER") then
			msg = Necrosis_MsgAddColor("<lightYellow>"..msg.."<close>");
			ChatFrame1:AddMessage("Necrosis: "..msg, 0.7, 0.7, 1);
		elseif (type == "WORLD") then
			if (GetNumRaidMembers() > 0) then
				SendChatMessage(msg, "RAID");
			elseif (GetNumPartyMembers() > 0) then
				SendChatMessage(msg, "PARTY");
			else
				SendChatMessage(msg, "SAY");
			end
		elseif (type == "CHANNEL") then
			SendChatMessage(msg, "CHANNEL", this.language, 3);
		end
	end
end

function Necrosis_SlashHandler(arg1)
	if (string.find(string.lower(arg1), "bag")) then
		local bag = tonumber(strsub(arg1, 5, strlen(arg1)));
		if (bag ~= nil) then
			if (bag == NecrosisConfig.SoulshardContainer) then
				Necrosis_Msg(Necrosis.Variable[Language].MsgBagError1, "USER");
			elseif (bag >= 0 and bag <= 4) then
				NecrosisConfig.SoulshardContainer = bag;
				Necrosis_SoulshardSetup();
				Necrosis_SoulshardSwitch("Check");
				Necrosis_Msg(Necrosis.Variable[Language].MsgBagSet1..GetBagName(bag)..Necrosis.Variable[Language].MsgBagSet2, "USER");
			else
				Necrosis_Msg(Necrosis.Variable[Language].MsgBagError2, "USER");
			end
		else
			Necrosis_Msg(Necrosis.Variable[Language].MsgBagError3, "USER");
		end
	elseif (string.lower(arg1) == "help") then
		local help = "";
		help = help..Necrosis.Variable[Language].MsgHelpCmd1.."\n";
		help = help..Necrosis.Variable[Language].MsgHelpCmd2.."\n";
		help = help..Necrosis.Variable[Language].MsgHelpCmd3.."\n";
		help = help..Necrosis.Variable[Language].MsgHelpCmd4.."\n";
		--help = help..Necrosis.Variable[Language].MsgHelpCmd5.."\n";
		help = help..Necrosis.Variable[Language].MsgHelpCmd6.."\n";
		help = help..Necrosis.Variable[Language].MsgHelpCmd7.."\n";
		help = help..Necrosis.Variable[Language].MsgHelpCmd8;
		Necrosis_Msg(help, "USER");
	elseif (string.lower(arg1) == "cdevour") then
		DevourUnit = {};
		Necrosis_Msg(Necrosis.Variable[Language].MsgDMagic1, "USER");
	elseif (string.find(string.lower(arg1), "devour")) then
		local name = strsub(arg1, 8, strlen(arg1));
		if (name ~= "" and not string.find(name, "%s")) then
			DevourUnit[string.upper(name)] = name;
			local part1 = strsub(name, 1, 1);
			local part2 = strsub(name, 2, strlen(name));
			name = string.upper(part1)..string.lower(part2);
			Necrosis_Msg(Necrosis.Variable[Language].MsgDMagic2..name..".", "USER");
		else
			Necrosis_Msg(Necrosis.Variable[Language].MsgDMagic3, "USER");
		end
	elseif (string.find(string.lower(arg1), "demonic")) then
		local msg = strsub(arg1, 9, strlen(arg1));
		if (GetNumRaidMembers() > 0) then
			SendChatMessage(msg, "RAID", "DEMONIC");
		elseif (GetNumPartyMembers() > 0) then
			SendChatMessage(msg, "PARTY", "DEMONIC");
		else
			Necrosis_Msg(Necrosis.Variable[Language].MsgDemonic, "USER");
		end
	elseif (string.lower(arg1) == "options") then
		Necrosis_Toggle();
	elseif (string.find(string.lower(arg1), "toggle")) then
		local item = string.upper(strsub(arg1, 8, strlen(arg1)));
		if (item == "SHADOWTRANCE") then
			Necrosis_Msg(Necrosis.Variable[Language].STButton, "USER");
			if (not NecrosisShadowTranceButton:IsVisible()) then
				NecrosisConfig.ShadowTranceAlert = false;
				NecrosisShadowTranceButton:Show();
			else
				NecrosisConfig.ShadowTranceAlert = true;
				NecrosisShadowTranceButton:Hide();
			end
		end
	elseif (string.lower(arg1) == "sticky") then
		if (NecrosisConfig.StickySpell) then
			NecrosisConfig.StickySpell = false;
		else
			NecrosisConfig.StickySpell = true;
		end
		Necrosis_Msg(Necrosis.Variable[Language].StickySpell..tostring(NecrosisConfig.StickySpell), "USER");
	end
end

----------------------------------------------------------------------------------------------------------------------------------------
-- INTERFACE FUNCTIONS
----------------------------------------------------------------------------------------------------------------------------------------

function Necrosis_Toggle()
	if (NecrosisOptionMenu:IsVisible()) then
		NecrosisOptionMenu:Hide();
	else
		NecrosisOptionMenu:Show();
	end
end

function Necrosis_OnDragStart(button)
	GameTooltip:Hide();
	button:StartMoving();
end

function Necrosis_OnDragStop(button)
	button:StopMovingOrSizing();
end

function Necrosis_BuildTooltip(button, type, anchor)
	GameTooltip:SetOwner(button, anchor);
	if (type == "Main") then
		GameTooltip:SetText("|C00FFFFFF"..Necrosis.Tooltip[Language][type].Title.."|r");
		GameTooltip:AddLine("|CFFFF99FF"..Necrosis.Tooltip[Language][type].Label[1]..":|r "..Soulshards);
		GameTooltip:AddLine("|CFFFF99FF"..Necrosis.Tooltip[Language][type].Label[2]..":|r "..Necrosis.Tooltip[Language][type].Stone[SoulstoneOnHand]);
		GameTooltip:AddLine("|CFF00FF00"..Necrosis.Tooltip[Language][type].Label[3]..":|r "..Necrosis.Tooltip[Language][type].Stone[HealthstoneOnHand]);
		-- Check if a Spellstone is equipped
		NecrosisTooltip:SetInventoryItem("player", 17);
		local rightHand = tostring(NecrosisTooltipTextLeft1:GetText());
		if (string.find(rightHand, "Spellstone")) then SpellstoneOnHand = true; end
		GameTooltip:AddLine("|CFF99CCFF"..Necrosis.Tooltip[Language][type].Label[4]..":|r "..Necrosis.Tooltip[Language][type].Stone[SpellstoneOnHand]);
		-- Check if a Firestone is equipped
		if (string.find(rightHand, "Firestone")) then FirestoneOnHand = true; end
		GameTooltip:AddLine("|CFFFF5555"..Necrosis.Tooltip[Language][type].Label[5]..":|r "..Necrosis.Tooltip[Language][type].Stone[FirestoneOnHand]);
		GameTooltip:AddLine("|CFF33CC33"..Necrosis.Tooltip[Language][type].Label[6]..":|r "..InfernalStones);
		GameTooltip:AddLine("|CFFFF8000"..Necrosis.Tooltip[Language][type].Label[7]..":|r "..DemonicFigurines);
	elseif (string.find(type, "stone")) then
		GameTooltip:SetText("|CFFFFFFFF"..Necrosis.Tooltip[Language][type].Title.."|r");
		if (type == "Soulstone") then
			GameTooltip:AddLine(Necrosis.Tooltip[Language][type].Text[SoulstoneMode]);
		elseif (type == "Healthstone") then
			GameTooltip:AddLine(Necrosis.Tooltip[Language][type].Text[HealthstoneMode]);
		elseif (type == "Spellstone") then
			GameTooltip:AddLine(Necrosis.Tooltip[Language][type].Text[SpellstoneMode]);
		elseif (type == "Firestone") then
			GameTooltip:AddLine(Necrosis.Tooltip[Language][type].Text[FirestoneMode]);
		end
	elseif (type == "ShadowTrance") then
		local rank = Necrosis_FindSpellAttribute(Necrosis.Variable[Language].spellName[3], "Rank");
		if (rank ~= nil) then
			if (rank > 0) then
				GameTooltip:SetText("|CFFFFFFFF"..Necrosis.Tooltip[Language][type].Title.."|r          |CFF808080"..Necrosis.Tooltip[Language].Rank.." "..rank.."|r");
			else
				GameTooltip:SetText("|CFFFFFFFF"..Necrosis.Tooltip[Language][type].Title.."|r          |CFF808080"..Necrosis.Tooltip[Language].NotKnown.."|r");
			end
		end
	elseif (type == "SpellTimer" or type == "Summoner" or type == "Mount") then
		GameTooltip:SetText("|CFFFFFFFF"..Necrosis.Tooltip[Language][type].Title.."|r");		
		GameTooltip:AddLine(Necrosis.Tooltip[Language][type].Text);
	elseif (type == "Summon Imp" or type == "Summon Voidwalker" or type == "Summon Succubus" or type == "Summon Felhunter" or type == "Inferno") then
		local spell = Necrosis.Tooltip[Language]["Spells"][type];
		local spellID = Necrosis_FindSpellAttribute(spell, "spellID");
		if (spellID ~= nil) then
			if (spellID > 0) then
				GameTooltip:SetText("|CFFFFFFFF"..spell.."|r          |CFF808080"..Necrosis.Tooltip[Language].Summon.."|r");
			else
				GameTooltip:SetText("|CFFFFFFFF"..spell.."|r          |CFF808080"..Necrosis.Tooltip[Language].NotKnown.."|r");
			end
		end
	elseif (type == "Enslave Demon") then
		local spell = Necrosis.Tooltip[Language]["Spells"][type];
		local rank = Necrosis_FindSpellAttribute(spell, "Rank");
		local spellID = Necrosis_FindSpellAttribute(spell, "spellID");
		if (spellID ~= nil) then
			if (spellID > 0) then
				GameTooltip:SetText("|CFFFFFFFF"..spell.."|r          |CFF808080"..Necrosis.Tooltip[Language].Rank.." "..rank.."|r");
			else
				GameTooltip:SetText("|CFFFFFFFF"..spell.."|r          |CFF808080"..Necrosis.Tooltip[Language].NotKnown.."|r");
			end
		end
	elseif (type == "Ritual of Doom" or type == "Curse of Doom") then
		local spell = Necrosis.Tooltip[Language]["Spells"][type];
		local rank = Necrosis_FindSpellAttribute(spell, "Rank");
		local spellID = Necrosis_FindSpellAttribute(spell, "spellID");
		if (spellID ~= nil) then
			if (spellID > 0) then
				GameTooltip:SetText("|CFFFFFFFF"..spell.."|r                  ");
			else
				GameTooltip:SetText("|CFFFFFFFF"..spell.."|r          |CFF808080"..Necrosis.Tooltip[Language].NotKnown.."|r");
			end
		end
	end
	GameTooltip:Show();
end

function Necrosis_UpdateStoneButtons()
	-- Graphical display of Soulstone multi-purpose button
	local soulstoneInUse = false;
	for index=1, table.getn(SpellTimer.Name), 1 do
		if (SpellTimer.Name[index] == "Soulstone Resurrection") then
			soulstoneInUse = true;
			break;
		end
	end
	if (soulstoneInUse) then
		SoulstoneMode = 3;
	else
		if (SoulstoneOnHand) then
			SoulstoneMode = 2;
		else
			SoulstoneMode = 1;
		end
	end
	NecrosisSoulstoneButton:SetNormalTexture("Interface\\AddOns\\Necrosis\\UI\\SoulstoneButton-0"..SoulstoneMode);
	-- Graphical display of Healthstone multi-purpose button
	if (HealthstoneOnHand) then
		HealthstoneMode = 2;
	else
		HealthstoneMode = 1;
	end
	NecrosisHealthstoneButton:SetNormalTexture("Interface\\AddOns\\Necrosis\\UI\\HealthstoneButton-0"..HealthstoneMode);
	-- Graphical display of Spellstone multi-purpose button
	Necrosis_MoneyToggle();
	Necrosis_ClearTooltip();
	NecrosisTooltip:SetInventoryItem("player", 17);
	Necrosis_MoneyToggle();
	local rightHand = tostring(NecrosisTooltipTextLeft1:GetText());
	if (string.find(rightHand, "Spellstone") and not SpellstoneOnHand) then
		SpellstoneMode = 3;
	else
		if (SpellstoneOnHand) then
			SpellstoneMode = 2;
		else
			SpellstoneMode = 1;
		end
	end
	NecrosisSpellstoneButton:SetNormalTexture("Interface\\AddOns\\Necrosis\\UI\\SpellstoneButton-0"..SpellstoneMode);
	-- Graphical display of Firestone multi-purpose button
	if (string.find(rightHand, "Firestone") and not FirestoneOnHand) then
		FirestoneMode = 3;
	else
		if (FirestoneOnHand) then
			FirestoneMode = 2;
		else
			FirestoneMode = 1;
		end
	end
	NecrosisFirestoneButton:SetNormalTexture("Interface\\AddOns\\Necrosis\\UI\\FirestoneButton-0"..FirestoneMode);
	-- Displaying the soulshard graphic counter with cover or not
	if (NecrosisConfig.SoulshardIcon) then
		if (not NecrosisDigitalCounter:IsVisible()) then
			NecrosisDigitalCounter:Show();
		end
		if (Soulshards < 17) then
			if (Soulshards > 9) then
				NecrosisButton:SetNormalTexture("Interface\\AddOns\\Necrosis\\UI\\Soulshard"..Soulshards.."c");
			else
				NecrosisButton:SetNormalTexture("Interface\\AddOns\\Necrosis\\UI\\Soulshard0"..Soulshards.."c");
			end
		else
			NecrosisButton:SetNormalTexture("Interface\\AddOns\\Necrosis\\UI\\Soulshard16c");
		end
	else
		if (NecrosisDigitalCounter:IsVisible()) then
			NecrosisDigitalCounter:Hide();
		end
		if (Soulshards < 17) then
			if (Soulshards > 9) then
				NecrosisButton:SetNormalTexture("Interface\\AddOns\\Necrosis\\UI\\Soulshard"..Soulshards);
			else
				NecrosisButton:SetNormalTexture("Interface\\AddOns\\Necrosis\\UI\\Soulshard0"..Soulshards);
			end
		else
			NecrosisButton:SetNormalTexture("Interface\\AddOns\\Necrosis\\UI\\Soulshard16");
		end
	end
end

function Necrosis_DisplayStoneButtons()
	if (NecrosisConfig.ShowSummoner) then
		if (not NecrosisSummonerButton:IsVisible()) then
			NecrosisSummonerButton:Show();
		end
	else
		if (NecrosisSummonerButton:IsVisible()) then
			NecrosisSummonerButton:Hide();
		end
	end
	if (NecrosisConfig.ShowMount) then
		if (not NecrosisMountButton:IsVisible()) then
			NecrosisMountButton:Show();
		end
	else
		if (NecrosisMountButton:IsVisible()) then
			NecrosisMountButton:Hide();
		end
	end
	if (NecrosisConfig.ShowSoulstone) then
		if (not NecrosisSoulstoneButton:IsVisible()) then
			NecrosisSoulstoneButton:Show();
		end
	else
		if (NecrosisSoulstoneButton:IsVisible()) then
			NecrosisSoulstoneButton:Hide();
		end
	end
	if (NecrosisConfig.ShowHealthstone) then
		if (not NecrosisHealthstoneButton:IsVisible()) then
			NecrosisHealthstoneButton:Show();
		end
	else
		if (NecrosisHealthstoneButton:IsVisible()) then
			NecrosisHealthstoneButton:Hide();
		end
	end
	if (NecrosisConfig.ShowSpellstone) then
		if (not NecrosisSpellstoneButton:IsVisible()) then
			NecrosisSpellstoneButton:Show();
		end
	else
		if (NecrosisSpellstoneButton:IsVisible()) then
			NecrosisSpellstoneButton:Hide();
		end
	end
	if (NecrosisConfig.ShowFirestone) then
		if (not NecrosisFirestoneButton:IsVisible()) then
			NecrosisFirestoneButton:Show();
		end
	else
		if (NecrosisFirestoneButton:IsVisible()) then
			NecrosisFirestoneButton:Hide();
		end
	end
end

function Necrosis_OpenMenu(name)
	local demon = {"Imp","Voidwalker","Succubus","Felhunter","Infernal","Doomguard"};
	for index=1, table.getn(demon), 1 do
		local menuOpen =  getglobal("Necrosis"..demon[index].."OptionMenu");
		if (name == demon[index]) then
			menuOpen:Show();
		else
			if (menuOpen:IsVisible()) then
				menuOpen:Hide();
			end
		end
	end
end

----------------------------------------------------------------------------------------------------------------------------------------
-- SOULSHARD/STONE FUNCTIONS
----------------------------------------------------------------------------------------------------------------------------------------

function Necrosis_SoulshardSetup()
	SoulshardSlot = {};
	local container = NecrosisConfig.SoulshardContainer;
	for slot=1, GetContainerNumSlots(container), 1 do
		Necrosis_MoneyToggle();
		Necrosis_ClearTooltip();
		NecrosisTooltip:SetBagItem(container, slot);
		Necrosis_MoneyToggle();
		local itemName = tostring(NecrosisTooltipTextLeft1:GetText());
		if (itemName ~= Necrosis.Tooltip[Language]["Main"].Label[1]) then
			table.insert(SoulshardSlot, nil);
		else
			table.insert(SoulshardSlot, slot);
		end
	end
end

function Necrosis_SoulshardTotal()
	Soulshards = 0;
	InfernalStones = 0;
	DemonicFigurines = 0;
	SoulstoneOnHand = false;
	HealthstoneOnHand = false;
	FirestoneOnHand= false;
	SpellstoneOnHand = false;
	for container=0, 4, 1 do
		for slot=1, GetContainerNumSlots(container), 1 do
			Necrosis_MoneyToggle();
			Necrosis_ClearTooltip();
			NecrosisTooltip:SetBagItem(container, slot);
			Necrosis_MoneyToggle();
			local itemName = tostring(NecrosisTooltipTextLeft1:GetText());
			if (container == NecrosisConfig.SoulshardContainer) then
				-- If there is a open slot anywhere in the bag reset it's value so it can be used
				if (itemName ~= Necrosis.Tooltip[Language]["Main"].Label[1]) then
					SoulshardSlot[slot] = nil;
				end
			end
			local _, itemCount, _, _, _ = GetContainerItemInfo(container, slot);
			if (itemName == Necrosis.Tooltip[Language]["Main"].Label[1]) then Soulshards = Soulshards+1; end
			if (string.find(itemName, Necrosis.Tooltip[Language]["Main"].Label[2])) then SoulstoneOnHand = true; end
			if (string.find(itemName, Necrosis.Tooltip[Language]["Main"].Label[3])) then HealthstoneOnHand = true; 	end
			if (string.find(itemName, Necrosis.Tooltip[Language]["Main"].Label[4])) then SpellstoneOnHand = true; end
			if (string.find(itemName, Necrosis.Tooltip[Language]["Main"].Label[5])) then FirestoneOnHand = true; end
			if (itemName == Necrosis.Tooltip[Language]["Main"].Label[6]) then InfernalStones = InfernalStones+itemCount; end
			if (itemName == Necrosis.Tooltip[Language]["Main"].Label[7]) then DemonicFigurines = DemonicFigurines+itemCount; end
		end
	end
	NecrosisSoulshardCount:SetText(Soulshards);
	Necrosis_UpdateStoneButtons();
end

function Necrosis_SoulshardSwitch(type)
	if (type == "Check") then SoulshardMP = 0; end
	for container=0, 4, 1 do
		if (container ~= NecrosisConfig.SoulshardContainer) then
			for slot=1, GetContainerNumSlots(container), 1 do
				Necrosis_MoneyToggle();
				Necrosis_ClearTooltip();
				NecrosisTooltip:SetBagItem(container, slot);
				Necrosis_MoneyToggle();
				local itemName = tostring(NecrosisTooltipTextLeft1:GetText());
				if (itemName == Necrosis.Tooltip[Language]["Main"].Label[1]) then
					if (type == "Check") then
						SoulshardMP = SoulshardMP+1;
					elseif (type == "Move") then
						Necrosis_FindSlot(container, slot);
						SoulshardMP = SoulshardMP-1;
						return;
					end
				end
			end
		end
	end
end

function Necrosis_FindSlot(shardIndex, shardSlot)
	local full = true;
	for slot=1, GetContainerNumSlots(NecrosisConfig.SoulshardContainer), 1 do
		Necrosis_MoneyToggle();
		Necrosis_ClearTooltip();
		NecrosisTooltip:SetBagItem(NecrosisConfig.SoulshardContainer, slot);
		Necrosis_MoneyToggle();
		local itemName = tostring(NecrosisTooltipTextLeft1:GetText());
		if (itemName ~= Necrosis.Tooltip[Language]["Main"].Label[1] and SoulshardSlot[slot] == nil) then
			PickupContainerItem(shardIndex, shardSlot);
			PickupContainerItem(NecrosisConfig.SoulshardContainer, slot);
			SoulshardSlot[slot] = slot;
			full = false;
			break;
		end
	end
	if (full and NecrosisConfig.SoulshardDestroy) then
		PickupContainerItem(shardIndex, shardSlot);
		if (CursorHasItem()) then
			DeleteCursorItem();
		end
	elseif (full) then
		SoulshardMP = 0;
	end
end

----------------------------------------------------------------------------------------------------------------------------------------
-- ITEM FUNCTIONS
----------------------------------------------------------------------------------------------------------------------------------------

function Necrosis_UseItem(type)
	Necrosis_MoneyToggle();
	Necrosis_ClearTooltip();
	NecrosisTooltip:SetBagItem("player", 17);
	Necrosis_MoneyToggle();
	local rightHand = tostring(NecrosisTooltipTextLeft1:GetText());
	if (type == "Soulstone") then
		-- Check to see if soulstone timer is on
		local soulstoneInUse = Necrosis_SpellTimerManage("HasTimer", Necrosis.Variable[Language].spellName[2]);
		if (SoulstoneOnHand and not soulstoneInUse) then
			local container, slot = Necrosis_FindItemName(Necrosis.Tooltip[Language]["Main"].Label[2]);
			if (UnitIsPlayer("target") and UnitIsFriend("player","target")) then
				if (container and slot) then
					UseContainerItem(container, slot);
				end
			else
				Necrosis_Targeting("Start");
				TargetUnit("player");
				if (container and slot) then
					UseContainerItem(container, slot);
				end
				Necrosis_Targeting("Stop");
			end
		elseif (SoulstoneMode == 1 or SoulstoneMode == 3 and not SoulstoneOnHand) then
			local spellID = Necrosis_FindSpellAttribute(Necrosis.Variable[Language].StoneName[1], "spellID");
			if (spellID > 0) then
				CastSpell(spellID, "spell");
			else
				Necrosis_Msg(Necrosis.Variable[Language].MsgSpellError1..Necrosis.Tooltip[Language]["Main"].Label[2], "USER");
			end
		else
		end
	elseif (type == "Healthstone") then
		if (HealthstoneOnHand) then
			if (UnitExists("target") and UnitIsPlayer("target") and UnitIsFriend("player", "target") and UnitName("target") ~= UnitName("player")) then
				local container, slot = Necrosis_FindItemName(Necrosis.Tooltip[Language]["Main"].Label[3]);
				if (container and slot) then
					PickupContainerItem(container, slot);
				end
				DropItemOnUnit("target");
			elseif (UnitHealth("player") == UnitHealthMax("player")) then
				Necrosis_Msg(Necrosis.Variable[Language].MsgNotHurt, "USER");
			else
				local container, slot = Necrosis_FindItemName(Necrosis.Tooltip[Language]["Main"].Label[3]);
				if (container and slot) then
					UseContainerItem(container, slot);
				end
			end
		elseif (HealthstoneMode == 1) then
			local spellID = Necrosis_FindSpellAttribute(Necrosis.Variable[Language].StoneName[2], "spellID");
			if (spellID > 0) then
				CastSpell(spellID, "spell");
			else
				Necrosis_Msg(Necrosis.Variable[Language].MsgSpellError1..Necrosis.Tooltip[Language]["Main"].Label[3], "USER");
			end
		else
		end
	elseif (type == "Spellstone") then
		if (SpellstoneOnHand or string.find(rightHand, Necrosis.Tooltip[Language]["Main"].Label[4]) or SpellstoneMode == 3) then
			Necrosis_SwitchOffHand(type);
		elseif (SpellstoneMode == 1) then
			local spellID = Necrosis_FindSpellAttribute(Necrosis.Variable[Language].StoneName[3], "spellID");
			if (spellID > 0) then
				CastSpell(spellID, "spell");
			else
				Necrosis_Msg(Necrosis.Variable[Language].MsgSpellError1..Necrosis.Tooltip[Language]["Main"].Label[4], "USER");
			end
		else
		end
	elseif (type == "Firestone") then
		if (FirestoneOnHand or string.find(rightHand, Necrosis.Tooltip[Language]["Main"].Label[5]) or FirestoneMode == 3) then
			Necrosis_SwitchOffHand(type);
		elseif (FirestoneMode == 1) then
			local spellID = Necrosis_FindSpellAttribute(Necrosis.Variable[Language].StoneName[4], "spellID");
			if (spellID > 0) then
				CastSpell(spellID, "spell");
			else
				Necrosis_Msg(Necrosis.Variable[Language].MsgSpellError1..Necrosis.Tooltip[Language]["Main"].Label[5], "USER");
			end
		else
		end
	end
end

function Necrosis_FindItemSlot()
	if (Debug) then Necrosis_Msg("Moving item from cursor.", "USER"); end
	for container=0, 4, 1 do
		for slot=1, GetContainerNumSlots(container), 1 do
			local itemInfo = GetContainerItemInfo(container, slot);
			if (itemInfo) then
				PickupContainerItem(container, slot);
				return true;
			end
		end
	end
	return false;
end

function Necrosis_FindItemName(name)
	for container=0, 4, 1 do
		for slot=1, GetContainerNumSlots(container), 1 do
			Necrosis_MoneyToggle();
			Necrosis_ClearTooltip();
			NecrosisTooltip:SetBagItem(container, slot);
			Necrosis_MoneyToggle();
			local itemName = tostring(NecrosisTooltipTextLeft1:GetText());
			if (string.find(itemName, name)) then
				return container, slot;
			end
		end
	end
	return nil, nil;
end

function Necrosis_FindTooltipText(searchText, searchType)
	local itemName = tostring(NecrosisTooltipTextLeft1:GetText());
	if (searchType == "Name") then
		if (string.find(itemName, searchText)) then
			return true;
		end
	elseif (searchType == "Attribute") then
		for index=2, 25, 1 do
			local text = getglobal("NecrosisTooltipTextLeft"..index);
			local itemString = tostring(text:GetText());
			if (string.find(itemString, searchText)) then
				if (not string.find(itemName, Necrosis.Tooltip[Language]["Main"].Label[4]) and not string.find(itemName, Necrosis.Tooltip[Language]["Main"].Label[5])) then
					return true;
				end
			end
		end
	end
	return false;
end

function Necrosis_SwitchOffHand(name)
	-- Set the text/type to search for
	local searchText = name;
	local searchType = "Name";
	if ((name == Necrosis.Tooltip[Language]["Main"].Label[4] and SpellstoneMode == 3) or (name == Necrosis.Tooltip[Language]["Main"].Label[5] and FirestoneMode == 3)) then
		searchText = "Held In Off";
		searchType = "Attribute";
	end
	if (name == Necrosis.Tooltip[Language]["Main"].Label[4]) then
		UseInventoryItem(17);
	end
	if (not PlayerCombat) then
		-- Find and switch with the designated item
		for container=0, 4, 1 do
			for slot=1, GetContainerNumSlots(container), 1 do
				Necrosis_MoneyToggle();
				Necrosis_ClearTooltip();
				NecrosisTooltip:SetBagItem(container, slot);
				Necrosis_MoneyToggle();
				if (Necrosis_FindTooltipText(searchText, searchType)) then
					PickupContainerItem(container, slot);
					PickupInventoryItem(17);
					if (GetInventoryItemLink("player", 17)) then
						if (Debug) then Necrosis_Msg("Switched "..GetInventoryItemLink("player", 17).." with "..GetContainerItemLink(container, slot), "USER"); end
					end
					return;
				end
			end
		end
		-- Try placing in open slot
		PickupInventoryItem(17);
		if (not Necrosis_FindItemSlot()) then
			PickupInventoryItem(17);
			Necrosis_Msg(Necrosis.Variable[Language].MsgSlotError..type..".", "USER");
		end
	else
		if (Debug) then Necrosis_Msg("You cannot switch items in combat.", "USER"); end
	end
end

----------------------------------------------------------------------------------------------------------------------------------------
-- SPELL FUNCTIONS
----------------------------------------------------------------------------------------------------------------------------------------

function Necrosis_SpellSetup()
	for spellID=1, MAX_SPELLS, 1 do
        		local spellName, subSpellName = GetSpellName(spellID, "spell");
		if (Spell[spellName] ~= nil) then
			Spell[spellName].spellID = spellID;
			if (string.find(subSpellName, Necrosis.Variable[Language].Rank)) then
				local rank = tonumber(strsub(subSpellName, 6, strlen(subSpellName)));
				if (Spell[spellName].Rank < rank) then
					Spell[spellName].Rank = rank;
				end
			end
		end
		for stone=1, table.getn(Necrosis.Variable[Language].StoneName), 1 do 
			local onStone = Necrosis.Variable[Language].StoneName[stone];
			for index=1, table.getn(Necrosis.Variable[Language].StoneRank), 1 do
				local onStoneName = Necrosis.Variable[Language].StoneSub1..onStone..Necrosis.Variable[Language].StoneSub2..Necrosis.Variable[Language].StoneRank[index];
				if (spellName == onStoneName) then
					if (Spell[onStone].Rank < index) then
						Spell[onStone].Name = onStoneName;
						Spell[onStone].spellID = spellID;
						Spell[onStone].Rank = index;
						break;
					end
				end
			end
		end
	end
	for index=1, table.getn(Necrosis.Variable[Language].ScalingSpell), 1 do
		local name = Necrosis.Variable[Language].ScalingSpell[index];
		if (Spell[name] ~= nil and Spell[name].spellID > 0) then
			Necrosis_MoneyToggle();
			Necrosis_ClearTooltip();
			NecrosisTooltip:SetSpell(Spell[name].spellID, "spell");
			Necrosis_MoneyToggle();
			local description = tostring(NecrosisTooltipTextLeft4:GetText());
			local stringCheck = string.gsub(Necrosis.Variable[Language].ScalingParse1, "(.+) sec.", "");
			if (string.find(description, stringCheck)) then
				for time in string.gfind(description, Necrosis.Variable[Language].ScalingParse1) do
					Spell[name].Time = tonumber(time);
				end
			else
				for time in string.gfind(description, Necrosis.Variable[Language].ScalingParse2) do
					Spell[name].Time = tonumber(time);
				end
			end
		end	
	end
end

function Necrosis_FindSpellAttribute(spellName, type)
	if (Spell[spellName] ~= nil) then
		if (type == "spellID") then
			return Spell[spellName].spellID;
		elseif (type == "Rank") then
			return Spell[spellName].Rank;
		end
	end
	return nil;
end

function Necrosis_CastShadowBolt()
	if (Necrosis_PlayerCanAttack()) then
		local spellID = Necrosis_FindSpellAttribute(Necrosis.Variable[Language].spellName[3], "spellID");
		if (spellID > 0) then
			CastSpell(spellID, "spell");
		else
			Necrosis_Msg(Necrosis.Variable[Language].MsgSBoltError, "USER");
		end
	else
		Necrosis_Msg(Necrosis.Variable[Language].MsgAttackError, "USER");
	end
end

function Necrosis_SpellTimerTarget(action, type)
	if (action == "Check" and UnitExists("target") and UnitIsEnemy("player","target")) then
		-- Find spells to add
		local targetSpells = {Name = {},Time = {}};
		local index = 1;
		while UnitDebuff("target", index) do
			Necrosis_MoneyToggle();
			Necrosis_ClearTooltip();
			NecrosisTooltip:SetUnitDebuff("target", index);
			Necrosis_MoneyToggle();
			local name = tostring(NecrosisTooltipTextLeft1:GetText());
			if (Spell[name] ~= nil) then
				table.insert(targetSpells.Name, Spell[name].Name);
				table.insert(targetSpells.Time, Spell[name].Time);
			end
			index = index+1;
		end
		-- If the spell doesn't have a timer add it
		for index=1, table.getn(targetSpells.Name), 1 do
			local found = false;
			for timer=1, table.getn(SpellTimer.Name), 1 do			
				if (targetSpells.Name[index] == SpellTimer.Name[timer]) then
					found = true;
					break;
				end
			end
			if (not found) then
				table.insert(SpellTimer.Name, targetSpells.Name[index]);
				table.insert(SpellTimer.Time, targetSpells.Time[index]);
				table.insert(SpellTimer.TimeMax, targetSpells.Time[index]);
				if (NecrosisConfig.StickySpell and (targetSpells.Name[index] == Necrosis.Variable[Language].DemonAvoid[6] or targetSpells.Name[index] == Necrosis.Variable[Language].DemonAvoid[1])) then
					table.insert(SpellTimer.Type, 1);
				else
					table.insert(SpellTimer.Type, 2);
				end
			end
		end
		-- Remove timers that are no longer active
		for index=1, table.getn(SpellTimer.Name), 1 do
			local found = false;
			for timer=1, table.getn(targetSpells.Name), 1 do	
				if (SpellTimer.Name[index] == targetSpells.Name[timer]) then
					found = true;
					break;
				end
			end
			if (not found and SpellTimer.Type[index] == 2) then
				table.remove(SpellTimer.Name, index);
				table.remove(SpellTimer.Time, index);
				table.remove(SpellTimer.TimeMax, index);
				table.remove(SpellTimer.Type, index);
			end
		end
	elseif (action == "Clear" and type) then
		for index=1, table.getn(SpellTimer.Name), 1 do
			if (SpellTimer.Type[index] == type) then
				table.remove(SpellTimer.Name, index);
				table.remove(SpellTimer.Time, index);
				table.remove(SpellTimer.TimeMax, index);
				table.remove(SpellTimer.Type, index);
			end
		end
	end
end

function Necrosis_SpellTimerManage(action, spellName, type)
	if (action == "Remove") then
		for index=1, table.getn(SpellTimer.Name), 1 do
			if (SpellTimer.Name[index] == spellName) then
				table.remove(SpellTimer.Name, index);
				table.remove(SpellTimer.Time, index);
				table.remove(SpellTimer.TimeMax, index);
				table.remove(SpellTimer.Type, index);
			end
		end
	elseif (action == "Insert" and Spell[spellName] and type) then
		table.insert(SpellTimer.Name, Spell[spellName].Name);
		table.insert(SpellTimer.Time, Spell[spellName].Time);
		table.insert(SpellTimer.TimeMax, Spell[spellName].Time);
		table.insert(SpellTimer.Type, type);
	elseif (action == "HasTimer") then
		for index=1, table.getn(SpellTimer.Name), 1 do
			if (SpellTimer.Name[index] == spellName) then
				return true;
			end
		end
		return false;
	end
	Necrosis_UpdateStoneButtons();
end

function Necrosis_SummonAction(arg1)
	if (arg1 == "LeftButton") then
		if (not NecrosisSummonerMenu:IsVisible()) then
			NecrosisSummonerMenu:Show();
		else
			NecrosisSummonerMenu:Hide();
		end
	elseif (arg1 == "RightButton") then
		Necrosis_Summoner("LeftButton", NecrosisConfig.SummonDemon);
	end
end

function Necrosis_Summoner(arg1, index)
	if (arg1 == "LeftButton") then
		if (index == 0) then
			local useSpell = nil;
			if (Spell[Necrosis.Variable[Language].spellName[4]].spellID > 0) then
				useSpell = Necrosis.Variable[Language].spellName[4];
			elseif (Spell[Necrosis.Variable[Language].spellName[5]].spellID > 0) then
				useSpell = Necrosis.Variable[Language].spellName[5];
			end
			if (useSpell) then
				CastSpell(Spell[useSpell].spellID, "spell");
			else
				Necrosis_Msg(Necrosis.Variable[Language].MsgMountError, "USER");			
			end
			return;
		else
			local spell = Necrosis.Variable[Language].Summoner[index];
			if (Spell[spell]) then
				local spellID = Necrosis_FindSpellAttribute(spell, "spellID");
				if (spellID ~= nil) then
					if (spellID > 0) then
						CastSpell(spellID, "spell");
					else
						Necrosis_Msg(Necrosis.Variable[Language].MsgSpellError1..spell, "USER");
					end
				end
			else
				Necrosis_Msg(Necrosis.Variable[Language].MsgSpellError1..tostring(spell), "USER");
			end
		end
	elseif (arg1 == "RightButton") then
		NecrosisConfig.SummonDemon = index;
		Necrosis_Msg("<white>(Set Right-Click) <lightYellow>Summoner:<close> "..Necrosis.Variable[Language].Summoner[index], "USER");
	end
end

----------------------------------------------------------------------------------------------------------------------------------------
-- DEMON FUNCTIONS
----------------------------------------------------------------------------------------------------------------------------------------

function Necrosis_DemonSetup()
	DemonSpell = {};
	for spellID=1, 12, 1 do
		Necrosis_MoneyToggle();
		Necrosis_ClearTooltip();
		NecrosisTooltip:SetSpell(spellID, "pet");
		Necrosis_MoneyToggle();
		local spellName = NecrosisTooltipTextLeft1:GetText();
		if (spellName) then
			-- Set loaded here to ensure it has loaded
			if (not DemonLoaded) then DemonLoaded = true; end
			local spellMana = tostring(NecrosisTooltipTextLeft2:GetText());
			if (string.find(spellMana, "Mana")) then
				spellMana = tonumber(strsub(spellMana, 1, strlen(spellMana)-5));
			else
				spellMana = 0;
			end
			DemonSpell[spellName] = {Name = spellName,Mana = spellMana};			
			if (Debug) then Necrosis_Msg("<white>(Added) <lightYellow>"..spellName.." <white>- <lightBlue>"..spellMana.." <white>mana", "USER"); end
		end
	end
	if (DemonLoaded) then
		if (Necrosis_UnitHasEffect("pet", Necrosis.Variable[Language].spellName[1])) then
			if (not DemonEnslaved) then
				DemonEnslaved = true;
				Necrosis_SpellTimerManage("Insert", Necrosis.Variable[Language].spellName[1], 1);
			end
		else
			if (DemonEnslaved) then
				DemonEnslaved = false;
				Necrosis_SpellTimerManage("Remove", Necrosis.Variable[Language].spellName[1]);
				Necrosis_Msg(Necrosis.Variable[Language].MsgEnslaveBroke, "USER");
				if (NecrosisConfig.PlaySounds) then
					PlaySoundFile("Interface\\AddOns\\Necrosis\\Sounds\\EnslaveDemon.mp3");
				end
			end
		end
	end
end

function Necrosis_DemonMonitor(curTime)
	local health = ceil((UnitHealth("pet")/UnitHealthMax("pet"))*100);
	if (health > 0 and health <= 30) then
		local lastInterval = DemonHPInterval;
		if (health <= 10) then
			DemonHPInterval = 6;
		elseif (health <= 20) then
			DemonHPInterval = 18;
		else
			DemonHPInterval = 30;
		end
		if ((curTime-DemonHPTime) > DemonHPInterval) then
			DemonHPTime = curTime;
			Necrosis_Msg(Necrosis.Variable[Language].MsgHeal..UnitName("pet").."  "..UnitHealth("pet").."  /  "..UnitHealthMax("pet").."  = "..health.."%", "WORLD");
		end
	end
end

function Necrosis_DemonSpellCaster()
	local dHP = UnitHealth("pet");
	local dHPMax = UnitHealthMax("pet");
	local dMP = UnitMana("pet");
	local dMPMax = UnitHealthMax("pet");
	local pHP = UnitHealth("player");
	local pHPMax = UnitHealthMax("player");
	local tHP = UnitHealth("target");
	local tHPMax = UnitHealthMax("target");
	if (HasPetUI() and GetPetActionsUsable()) then
		if (DemonType == Necrosis.Variable[Language].Voidwalker) then
			if (DemonSpell[Necrosis.Variable[Language].ConsumeShadows] and not PlayerCombat and not DemonCombat) then
				if (Necrosis_DemonActionAvailable(Necrosis.Variable[Language].ConsumeShadows) and not Necrosis_UnitHasEffect("pet", Necrosis.Variable[Language].ConsumeShadows)) then
					if (dMP >= DemonSpell[Necrosis.Variable[Language].ConsumeShadows].Mana and dHP <= (dHPMax*NecrosisConfig[Necrosis.Variable[Language].Voidwalker].ConsumeShadows) and dMP >= (dMPMax*NecrosisConfig[Necrosis.Variable[Language].Voidwalker].ConsumeShadowsMana)) then
						Necrosis_DemonCastAction(Necrosis.Variable[Language].ConsumeShadows);
					end
				end
			end
			if (DemonSpell[Necrosis.Variable[Language].Sacrifice] and (PlayerCombat or DemonCombat)) then
				if (Necrosis_DemonActionAvailable(Necrosis.Variable[Language].Sacrifice) and not Necrosis_UnitHasEffect("player", Necrosis.Variable[Language].Sacrifice)) then
					if (dMP >= DemonSpell[Necrosis.Variable[Language].Sacrifice].Mana and (dHP <= (dHPMax*NecrosisConfig[Necrosis.Variable[Language].Voidwalker].SacrificeDemon) or pHP <= (pHPMax*NecrosisConfig[Necrosis.Variable[Language].Voidwalker].SacrificePlayer))) then		
						Necrosis_DemonCastAction(Necrosis.Variable[Language].Sacrifice);
					end
				end
			end
		elseif (DemonType == Necrosis.Variable[Language].Succubus) then
			if (DemonSpell[Necrosis.Variable[Language].LesserInvisibility] and not PlayerCombat and not DemonKeepTarget) then
				if (not Necrosis_UnitHasEffect("pet", Necrosis.Variable[Language].LesserInvisibility) and not Necrosis_UnitHasTexture("player", "Nature_Swiftness") and not Necrosis_UnitHasTexture("player", "Mount")) then
					if (Necrosis_DemonActionAvailable(Necrosis.Variable[Language].LesserInvisibility)) then
						if (dMP >= DemonSpell[Necrosis.Variable[Language].LesserInvisibility].Mana and dMP > (dMPMax*NecrosisConfig[Necrosis.Variable[Language].Succubus].Invisible)) then
							Necrosis_DemonCastAction(Necrosis.Variable[Language].LesserInvisibility);
						end
					end
				end
			end
			if (DemonSpell[Necrosis.Variable[Language].Seduction] and (PlayerCombat or DemonCombat)) then
				if (not Necrosis_UnitHasEffect("target", Necrosis.Variable[Language].Seduction)) then
					DemonKeepTarget = false;
					if (Necrosis_DemonActionAvailable(Necrosis.Variable[Language].Seduction)) then
						if (dMP >= DemonSpell[Necrosis.Variable[Language].Seduction].Mana and UnitCreatureType("target") == "Humanoid" and tHP > (tHPMax*NecrosisConfig[Necrosis.Variable[Language].Succubus].Seduction)) then
							--Necrosis_DemonCastAction(Necrosis.Variable[Language].Seduction);
							DemonKeepTarget = true;
						end
					end
				else
					DemonKeepTarget = true;
				end
			end
		elseif (DemonType == Necrosis.Variable[Language].Felhunter) then
			if (DemonSpell[Necrosis.Variable[Language].DevourMagic]) then
				if (Necrosis_DemonActionAvailable(Necrosis.Variable[Language].DevourMagic) and dMP >= DemonSpell[Necrosis.Variable[Language].DevourMagic].Mana) then
					local hasDebuff = Necrosis_UnitHasMagicDebuff("player");
					if (Necrosis_CanDevourMagic(hasDebuff)) then
						Necrosis_DevourMagic("player", NecrosisConfig[Necrosis.Variable[Language].Felhunter].Player, UnitName("player"), hasDebuff);
						return;
					end
					hasDebuff = Necrosis_UnitHasMagicDebuff("pet");
					if (Necrosis_CanDevourMagic(hasDebuff)) then
						Necrosis_DevourMagic("pet", NecrosisConfig[Necrosis.Variable[Language].Felhunter].Pet, UnitName("pet"), hasDebuff);
						return;
					end
					for index=1, GetNumRaidMembers(), 1 do
						local name, _, _, _, _, _, _, _ = GetRaidRosterInfo(index);
						hasDebuff = Necrosis_UnitHasMagicDebuff("raid"..index);
						if (Necrosis_CanDevourMagic(hasDebuff)) then
							Necrosis_DevourMagic("raid"..index, NecrosisConfig[Necrosis.Variable[Language].Felhunter].Raid, name, hasDebuff);
							return;
						end
					end
					for index=1, GetNumPartyMembers(), 1 do
						hasDebuff = Necrosis_UnitHasMagicDebuff("party"..index);
						if (Necrosis_CanDevourMagic(hasDebuff)) then
							Necrosis_DevourMagic("party"..index, NecrosisConfig[Necrosis.Variable[Language].Felhunter].Raid, UnitName("party"..index), hasDebuff);
							return;
						end
					end
				end
			end
		end
	end
end

function Necrosis_DemonAttack(type)
	if (type == "Player") then
		if (Necrosis_DemonCanAttack()) then
			TargetUnit("target");
			PetAttack();
		end
	end
end

function Necrosis_DemonCanAttack()
	if (not UnitExists("target")) then
		return false;
	elseif (not UnitIsEnemy("pet","target")) then
		return false;
	elseif (NecrosisConfig[DemonType].FollowFocus) then
		if (not UnitIsPlayer("player","target")) then
			if (not UnitIsTapped("target")) then
				return false;
			elseif (not UnitIsTappedByPlayer("target")) then
				return false;
			end
		else
			if (not UnitIsPVP("player")) then
				return false;
			elseif (UnitHealth("target") == UnitHealthMax("target")) then
				return false;
			end
		end
	elseif (UnitIsCorpse("target")) then
		return false;
	elseif (UnitIsDead("target")) then
		return false;
	end
	return true;
end

function Necrosis_DemonCastAction(action)
	for slot=1, NUM_PET_ACTION_SLOTS, 1 do
		local name, _, _, _, _, _, _ = GetPetActionInfo(slot);			
		if (name == action) then
			CastPetAction(slot);
		end
	end
end

function Necrosis_DemonActionAvailable(action)
	for slot=1, NUM_PET_ACTION_SLOTS, 1 do
		local name, _, _, _, _, _, _ = GetPetActionInfo(slot);
		if (name == action) then
			local startTime, duration, enabled = GetPetActionCooldown(slot);
			if (startTime == 0 and duration == 0 and enabled == 1) then
				return true;
			else
				return false;
			end
		end
	end
end

function Necrosis_DemonLeash()
	for index=1, table.getn(DemonAvoid), 1 do
		if (Necrosis_UnitHasEffect("target", DemonAvoid[index])) then
			-- Ignore if your pet is a succubus and the target is seduced
			if (DemonType == Necrosis.Variable[Language].DemonLeash1 and DemonAvoid[index] == Necrosis.Variable[Language].DemonLeash2) then
				return false;
			end
			PetFollow();
			return true;
		end
	end
	return false;
end

function Necrosis_DevourMagic(unit, devour, name, debuff)
	if (devour or (NecrosisConfig[Necrosis.Variable[Language].Felhunter].DevourByName and DevourUnit[string.upper(name)] ~= nil)) then
		if (NecrosisConfig[Necrosis.Variable[Language].Felhunter].DevourNotice) then
			Necrosis_Msg(Necrosis.Variable[Language].MsgDMagic4..name.."<close> ("..debuff..")", "USER");
		end
		Necrosis_Targeting("Start");
		TargetUnit(unit);
		Necrosis_DemonCastAction(Necrosis.Variable[Language].DevourMagic);
		Necrosis_Targeting("Stop");
	end
end

----------------------------------------------------------------------------------------------------------------------------------------
-- DEBUFF DATABASE FUNCTIONS
----------------------------------------------------------------------------------------------------------------------------------------

function Necrosis_UnitHasMagicDebuff(unit)
	local index = 1;
	while UnitDebuff(unit, index) do
		Necrosis_MoneyToggle();
		Necrosis_ClearTooltip();
		NecrosisTooltip:SetUnitDebuff(unit, index);
		Necrosis_MoneyToggle();
		local name = NecrosisTooltipTextLeft1:GetText();
		local type = NecrosisTooltipTextRight1:GetText();
		if (type == "Magic") then
			if (NecrosisDebuffDatabase.Description[name]) then
				return name;
			end
		end
		index = index+1;
	end
	return nil;
end

function Necrosis_AddDebuff(unit)
	local index = 1;
	while UnitDebuff(unit, index) do
		Necrosis_MoneyToggle();
		Necrosis_ClearTooltip();
		NecrosisTooltip:SetUnitDebuff(unit, index);
		Necrosis_MoneyToggle();
		local name = NecrosisTooltipTextLeft1:GetText();
		local description = NecrosisTooltipTextLeft2:GetText();
		local type = NecrosisTooltipTextRight1:GetText();
		if (type == "Magic") then
			if (not NecrosisDebuffDatabase.Description[name]) then
				if (description) then
					NecrosisDebuffDatabase.Description[name] = "(NEW) "..description;
				else
					NecrosisDebuffDatabase.Description[name] = Necrosis.Variable[Language].MsgDebuffNone;
				end
				local newIndex = table.getn(NecrosisDebuffDatabase.Name);
				NecrosisDebuffDatabase.Name[newIndex+1] = name;
				Necrosis_Msg(Necrosis.Variable[Language].MsgDebuffAdd1..name..Necrosis.Variable[Language].MsgDebuffAdd2, "USER");
			end
		end
		index = index+1;
	end
end

function Necrosis_CheckDebuffDatabase()
	Necrosis_AddDebuff("mouseover");
	Necrosis_AddDebuff("target");
	Necrosis_AddDebuff("pet");
	Necrosis_AddDebuff("player");
	Necrosis_AddDebuff("party1");
	Necrosis_AddDebuff("party2");
	Necrosis_AddDebuff("party3");
	Necrosis_AddDebuff("party4");
end

function Necrosis_UpdateDebuffDatabase()
	if (NecrosisDebuffDatabase.Name) then
		FauxScrollFrame_Update(DebuffDatabaseListScrollFrame, table.getn(NecrosisDebuffDatabase.Name), 23, 16);
		for item=1, 23, 1 do
			local itemIndex = item+FauxScrollFrame_GetOffset(DebuffDatabaseListScrollFrame);
			local DebuffDatabaseItemSlot = getglobal("DebuffDatabaseItem"..item);
			if (itemIndex <= table.getn(NecrosisDebuffDatabase.Name)) then
				local name = NecrosisDebuffDatabase.Name[itemIndex];
				if (name == DebuffSelection) then
					DebuffDatabaseItemSlot:SetTextColor(1, 1, 0);
				elseif (name == Necrosis.Interface[Language][1]) then
					DebuffDatabaseItemSlot:SetTextColor(1, 0, 0);
				else
					DebuffDatabaseItemSlot:SetTextColor(1, 1, 1);
				end
				DebuffDatabaseItemSlot:SetText(name);
				DebuffDatabaseItemSlot:Show();
			else
				DebuffDatabaseItemSlot:Hide();
			end
		end
	end
end

function Necrosis_CanDevourMagic(debuffName)
	index = 1;
	while (NecrosisDebuffDatabase.Name[index] ~= Necrosis.Interface[Language][1]) do
		if (NecrosisDebuffDatabase.Name[index] == debuffName) then
			return true;
		end
		index = index+1;
	end
	return false;
end

function Necrosis_MoveQuickDebuffListing(type)
	if (type == "Top") then
		for index=table.getn(NecrosisDebuffDatabase.Name), 2, -1 do
			if (NecrosisDebuffDatabase.Name[index] == DebuffSelection) then
				local temp = NecrosisDebuffDatabase.Name[index-1];
				NecrosisDebuffDatabase.Name[index-1] = NecrosisDebuffDatabase.Name[index];
				NecrosisDebuffDatabase.Name[index] = temp;
			end
		end
	elseif (type == "Bottom") then
		for index=1, table.getn(NecrosisDebuffDatabase.Name)-1, 1 do
			if (NecrosisDebuffDatabase.Name[index] == DebuffSelection) then
				local temp = NecrosisDebuffDatabase.Name[index+1];
				NecrosisDebuffDatabase.Name[index+1] = NecrosisDebuffDatabase.Name[index];
				NecrosisDebuffDatabase.Name[index] = temp;
			end
		end
	end
end

function Necrosis_MoveDebuffListing(type)
	if (type == "Up") then
		for index=2, table.getn(NecrosisDebuffDatabase.Name), 1 do
			if (NecrosisDebuffDatabase.Name[index] == DebuffSelection) then
				local temp = NecrosisDebuffDatabase.Name[index-1];
				NecrosisDebuffDatabase.Name[index-1] = NecrosisDebuffDatabase.Name[index];
				NecrosisDebuffDatabase.Name[index] = temp;
				return;
			end
		end
	elseif (type == "Down") then
		for index=1, table.getn(NecrosisDebuffDatabase.Name)-1, 1 do
			if (NecrosisDebuffDatabase.Name[index] == DebuffSelection) then
				local temp = NecrosisDebuffDatabase.Name[index+1];
				NecrosisDebuffDatabase.Name[index+1] = NecrosisDebuffDatabase.Name[index];
				NecrosisDebuffDatabase.Name[index] = temp;
				return;
			end
		end
	end
end

function Necrosis_OnEnterDebuffDatabase()
	local debuffName = this:GetText();
	GameTooltip:SetOwner(this, "ANCHOR_RIGHT");
	if (debuffName == Necrosis.Interface[Language][1]) then
		GameTooltip:SetText(Necrosis.Variable[Language].MsgDebuff, 1, 1, 1);
	else
		GameTooltip:SetText(NecrosisDebuffDatabase.Description[this:GetText()], 1, 1, 1);
	end
end

----------------------------------------------------------------------------------------------------------------------------------------
-- MISC FUNCTIONS
----------------------------------------------------------------------------------------------------------------------------------------

function Necrosis_UnitHasEffect(unit, spellName)
	if (UnitExists(unit)) then
		local index = 1;
		while UnitBuff(unit, index) do
			Necrosis_MoneyToggle();
			Necrosis_ClearTooltip();
			NecrosisTooltip:SetUnitBuff(unit, index);
			Necrosis_MoneyToggle();
			local buffName = tostring(NecrosisTooltipTextLeft1:GetText());
			if (buffName == spellName) then
				return true;
   			end
			index = index+1;
		end
		index = 1;
		while UnitDebuff(unit, index) do
			Necrosis_MoneyToggle();
			Necrosis_ClearTooltip();
			NecrosisTooltip:SetUnitDebuff(unit, index);
			Necrosis_MoneyToggle();
			local debuffName = tostring(NecrosisTooltipTextLeft1:GetText());
			if (debuffName == spellName) then
				return true;
   		 	end
			index = index+1;
		end
	end
	return false;
end

function Necrosis_UnitHasTexture(unit, search)
	if (UnitExists(unit)) then
		local index = 1;
		while UnitBuff(unit, index) do
			if (string.find(UnitBuff(unit, index), search)) then
				return true;
   			end
			index = index+1;
		end
		index = 1;
		while UnitDebuff(unit, index) do
			if (string.find(UnitDebuff(unit, index), search)) then
				return true;
   			end
			index = index+1;
		end
	end
	return false;
end

function Necrosis_PlayerCanAttack()
	if (UnitExists("target") and UnitIsEnemy("player","target") and UnitHealth("target") > 0) then
		return true;
	else
		return false;
	end
end

function Necrosis_Targeting(type)
	if (type == "Start") then
		if (not UnitExists("target")) then
			Target.Type = "Clear";
		elseif (UnitIsEnemy("player", "target")) then
			Target.Type = "Enemy";
		elseif (UnitIsPlayer("target")) then
			Target.Type = "Player";
			Target.Name = UnitName("target");
		else
			Target.Type = "Other";
			Target.Name = UnitName("target");
		end
	elseif (type == "Stop") then
		if (Target.Type == "Clear") then
			ClearTarget();
		elseif (Target.Type == "Enemy") then
			TargetLastEnemy();
		else
			TargetByName(Target.Name);
		end
		Target.Type = nil;
		Target.Name = nil;
	end
end

function Necrosis_GetSoulStoneTime()
	local timeLeft;
	local isMinutes;
	for container=0, 4, 1 do
		for slot=1, GetContainerNumSlots(container), 1 do
			Necrosis_MoneyToggle();
			Necrosis_ClearTooltip();
			NecrosisTooltip:SetBagItem(container, slot);
			Necrosis_MoneyToggle();
			local itemName = tostring(NecrosisTooltipTextLeft1:GetText());
			if (string.find(itemName, Necrosis.Tooltip[Language]["Main"].Label[2])) then 
				local timeRemainingText = tostring(NecrosisTooltipTextLeft6:GetText());
				for theTime in string.gfind(timeRemainingText, "%d+") do
					timeLeft = tonumber(theTime);
				end
				isMinutes = (not string.find(timeRemainingText, Necrosis.Variable[Language].ParseSeconds));
				return timeLeft, isMinutes;
			end
		end
	end
end

local lOriginal_GameTooltip_ClearMoney;
function Necrosis_MoneyToggle()
    if (lOriginal_GameTooltip_ClearMoney) then
        GameTooltip_ClearMoney = lOriginal_GameTooltip_ClearMoney;
        lOriginal_GameTooltip_ClearMoney = nil;
    else
        lOriginal_GameTooltip_ClearMoney = GameTooltip_ClearMoney;
        GameTooltip_ClearMoney = Necrosis_GameTooltip_ClearMoney;
    end
end
function Necrosis_GameTooltip_ClearMoney()
end

function Necrosis_ClearTooltip()
	for index=1, 25, 1 do
		local text = getglobal("NecrosisTooltipTextLeft"..index);
		text:SetText(nil);
		text = getglobal("NecrosisTooltipTextRight"..index);
		text:SetText(nil);
	end
end